:i	static char str_chksm_sccs_id[] = "%W% %G%";
#include "V_M.h"
#include "str.h"

/*
* Check a string structure for validity. Return the number of errors. The only
* errors counted are the ones that might prevent use of the string. We may add
* diagnostic messages for situations that aren't  strictly  errors,  as  added
* debugging aids.
*/
int str_chksm(src,msg)
	Str *src;	/* The Str data structure to check */
	char*msg;	/* Message describing the string */
{	int  e=0;	/* Number of errors */
:2	if (!msg) msg = unknown;
/*
* Overflow check: if a string is allocated, we must have l <= m.
*/
	if (src->m) {				/* Is the string allocated? */
		if (src->m < src->l) {	/* The l field must be valid */
:2			V2M "### Invalid string l=%d > m=%d [%s]",src->l,src->m,msg D;
			++e;
		}
	}
/*
* Null strings must not have positive l or m fields.
*/
	if (!src->v) {	/* Is there a string at all? */
		if (src->l || src->m) {	/* If not, it must not have a length */
:2			V2M "### Invalid null string v=%X l=%d m=%d [%s]",
:2				src->v,src->l,src->m,msg D;
			++e;
		}
	}
/*
* If the p field is nonnull, it must be within [v,v+m], and should  be
* within  [v,v+l]  (except while extending the string).  We might make
* this mandatory for non-null strings sometime, by changing the  first
* test to the v field.
*/
	if (src->p) {		/* Is there a p field? */
		if (V(src->p) < V(src->v)) {
:2			V2M "### Invalid string p=%X < v=%X [%s]",
:2				src->p,src->v,src->l,src->v+src->l,msg D;
			src->p = src->v;
			++e;
		}
		if (src->m && (V(src->p) > (V(src->v) + src->m))) {
:2			V2M "### Invalid string p=%X > v=%X + m=%d end=%X [%s]",
:2				src->p,src->v,src->m,src->v+src->m,msg D;
			src->p = src->v;
			++e;
		}
		if (V(src->p) > (V(src->v) + src->l)) {
:3			V4M "??? Suspect string p=%X > v=%X + l=%d end=%X [%s]",
:3				src->p,src->v,src->l,src->v+src->l,msg D;
			src->p = src->v;
			/* This isn't fatal, so we don't count it */
		}
	}
	return e;
}
